<?php
/*
  www.oscGold.com (C) Kamelia-Net Jacek Krysiak
  modul oscGold wer 4.0
*/

  class ot_klub {
    var $title, $output;

    function ot_klub() {
      $this->code = ot_klub;
      $this->title = MODULE_KLUB_TITLE;
      $this->description = MODULE_KLUB_DESCRIPTION;
      $this->enabled = MODULE_KLUB_STATUS;
      $this->sort_order = MODULE_KLUB_SORT_ORDER;
      $this->include_shipping = MODULE_KLUB_INC_SHIPPING;
      $this->table = MODULE_KLUB_TABLE;
	  $this->loyalty_order_status = MODULE_KLUB_ORDER_STATUS;
	  $this->cum_order_period = MODULE_KLUB_CUMORDER_PERIOD;
      $this->output = array();
    }

function process() {
	global $order, $ot_subtotal, $currencies, $customer_id, $customer_discount;

    //$query = tep_db_query("select customers_discount from " . TABLE_CUSTOMERS . " where customers_id =  '" . $customer_id . "'");
	//$query_result = tep_db_fetch_array($query);
	//$customer_discount = $query_result['customers_discount'];

    //if ($customer_discount >= 0 ) {
	 $od_amount = $this->calculate_credit($this->get_order_total(), $this->get_cum_order_total());

	 $od_amount = round($od_amount, 2);
	  if ($od_amount>0) { 
		 $this->deduction = $od_amount;
		 $this->output[] = array('title' => $this->title . '.<br>' . MODULE_KLUB_QUALIFY . $currencies->format($this->od_pc) . ':',
								'text' => '<b>-' . $currencies->format($od_amount) .'<b>' ,
								'value' => $od_amount);
		 $order->info['total'] = $order->info['total'] - $od_amount;
		 if ($this->sort_order < $ot_subtotal->sort_order) {
			$order->info['subtotal'] = $order->info['subtotal'] - $od_amount;
		 }
		}
    //}
} // end of function process()
	  
   
function calculate_credit($amount_order, $amount_cum_order) {
    global $order;
	if (suma_zamowien() > MODULE_KLUB_KWOTA) {
	    $od_amount=0;
	    $table_cost = split("[:,]" , MODULE_KLUB_TABLE);
	    for ($i = 0; $i < count($table_cost); $i+=2) {
	          if ($amount_order >= $table_cost[$i]) {
	            $od_pc = $table_cost[$i+1];
				$this->od_pc = $od_pc;
	          }
	    }
	    //$od_amount = $amount_order*$od_pc/100;
		$od_amount = $od_pc;
		} else {
		$od_amount = 0;
	}
    return $od_amount;
  }


  function get_order_total() {
    global  $order, $cart;
    $order_total = $order->info['total'];
    // Check if gift voucher is in cart and adjust total
    $products = $cart->get_products();
    for ($i=0; $i<sizeof($products); $i++) {
      $t_prid = tep_get_prid($products[$i]['id']);
      $gv_query = tep_db_query("select products_price, products_tax_class_id, products_model from " . TABLE_PRODUCTS . " where products_id = '" . $t_prid . "'");
      $gv_result = tep_db_fetch_array($gv_query);
      if (ereg('^GIFT', addslashes($gv_result['products_model']))) { 
        $qty = $cart->get_quantity($t_prid);
        $products_tax = tep_get_tax_rate($gv_result['products_tax_class_id']);
        $gv_amount = ($gv_result['products_price'] + tep_calculate_tax($gv_result['products_price'],$products_tax)) * $qty;
        $order_total=$order_total - $gv_amount;
      }
    }
    $order_total=$order_total-$order->info['shipping_cost'];
    return $order_total;
  }   
    
	function get_cum_order_total() {
	  global $order, $customer_id;
	  $history_query_raw = "select o.date_purchased, ot.value as order_total from " . TABLE_ORDERS . " o left join " . TABLE_ORDERS_TOTAL . " ot on (o.orders_id = ot.orders_id) where o.customers_id = '" . $customer_id . "' and ot.class = 'ot_total' and o.orders_status >= '" . $this->loyalty_order_status . "' order by date_purchased DESC";
  	  $history_query = tep_db_query($history_query_raw);
	  if (tep_db_num_rows($history_query)) {
	  $cum_order_total = 0;
	  $cutoff_date = $this->get_cutoff_date();
      while ($history = tep_db_fetch_array($history_query)) {
	    if ($this->get_date_in_period($cutoff_date, $history['date_purchased']) == true){
	    $cum_order_total = $cum_order_total + $history['order_total'];
	    }
	  }
	  $this->cum_order_total = $cum_order_total;
	  return $cum_order_total;
	  
	  }	
	  else {
	  $cum_order_total = 0;
	  $this->cum_order_total = $cum_order_total;
	  return $cum_order_total;
	  }	
	}
    
	function get_cutoff_date() {
	  $rightnow = time();
	  $cutoff_date = $rightnow - (60*60*24*(int)$this->cum_order_period);
	  return $cutoff_date;
	}
	
      function get_date_in_period($cutoff_date, $raw_date) {
    if ( ($raw_date == '0000-00-00 00:00:00') || ($raw_date == '') ) return false;
	
    $year = (int)substr($raw_date, 0, 4);
    $month = (int)substr($raw_date, 5, 2);
    $day = (int)substr($raw_date, 8, 2);
    $hour = (int)substr($raw_date, 11, 2);
    $minute = (int)substr($raw_date, 14, 2);
    $second = (int)substr($raw_date, 17, 2);

    $order_date_purchased = mktime($hour,$minute,$second,$month,$day,$year);
	if ($order_date_purchased >= $cutoff_date) {return true;}
	else {return false;}
  }
  
  
    function check() {
      if (!isset($this->check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_KLUB_STATUS'");
        $this->check = tep_db_num_rows($check_query);
      }

      return $this->check;
    }

    function keys() {
      return array('MODULE_KLUB_STATUS', 'MODULE_KLUB_KWOTA', 'MODULE_KLUB_SORT_ORDER', 'MODULE_KLUB_CUMORDER_PERIOD', 'MODULE_KLUB_TABLE', 'MODULE_KLUB_INC_SHIPPING', 'MODULE_KLUB_ORDER_STATUS');
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Klub przyjaciół - program lojalnościowy', 'MODULE_KLUB_STATUS', 'true', 'Czy włączyć program lojalnościowy ?', '6', '1','tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Kolejność wyświetlania', 'MODULE_KLUB_SORT_ORDER', '999', 'Kolejność wyświetlania znizki.', '6', '2', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function ,date_added) values ('Darmowa przesyłka dla klubowiczów', 'MODULE_KLUB_INC_SHIPPING', 'true', 'Włączenie darmowych kosztów przesyłki', '6', '3', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
	  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function ,date_added) values ('Kwota kwalifikująca do klubu', 'MODULE_KLUB_KWOTA', '1000', 'Suma zamówień jaka musi zostać zebrana aby klient trafił do klubu.', '6', '4','', now())");
	  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function ,date_added) values ('Okres naliczania zniżki', 'MODULE_KLUB_CUMORDER_PERIOD', '30', 'Okres przez, który zakupy klienta są kumulowane (ilość dni).', '6', '5','', now())");	  
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Progi zniżek', 'MODULE_KLUB_TABLE', '500:10,1000:20,1500:30,2000:40', 'Ustaw progi wysokości zakupów i odpowiadający im rabat.', '6', '6', now())");
	  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Status zamówień do wyliczania zniżek', 'MODULE_KLUB_ORDER_STATUS', '3', 'Ustaw status jaki muszą mieć zamówienia, które będą wliczane do ustalenia zniżki', '6', '7', 'tep_get_order_status_name', 'tep_cfg_pull_down_order_statuses(', now())");
    }

    function remove() {
      $keys = '';
      $keys_array = $this->keys();
      for ($i=0; $i<sizeof($keys_array); $i++) {
        $keys .= "'" . $keys_array[$i] . "',";
      }
      $keys = substr($keys, 0, -1);

      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in (" . $keys . ")");
    }
  }
?>